//------------------------------------------------------------------------------
//
// Copyright (C) 2004 Gehriger Engineering.
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//------------------------------------------------------------------------------
#ifndef STUFF_H
#define STUFF_H
#ifdef _MSC_VER
#pragma once
#endif

#if defined (_UNICODE) && !defined(UNICODE)
#define UNICODE
#endif

// include Windows headers
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#pragma warning(disable : 4786) // disable warnings about debug info
#pragma warning(disable : 4290) // disable exception spec warning
#define WINVER 0x0400
#include <windows.h>

// include MSI stuff
#include <Msi.h> 
//       ^^^^^^^
// If this include statement fails, you need to download and install
// the Windows Installer SDK, which is included in the Windows Platform SDK
// or can be downloaded from :
//
// http://msdn.microsoft.com/code/sample.asp?url=/msdn-files/027/001/457/msdncompositedoc.xml
//
// You also need to add the include file and library search path
// to Visual C++'s list of directories (Tools > Options... > Directories).
#include <Msiquery.h>
#include <MsiDefs.h>

// Helper function for return code validation
#include <crtdbg.h>
#include <comdef.h>
inline void OK(HRESULT hr)
{
    _ASSERTE(hr == ERROR_SUCCESS);
    if (hr != ERROR_SUCCESS) 
    {
        _com_issue_error(hr);
    }
}

#endif // STUFF_H
